<template>
	<v-card>
		<v-toolbar color="primary">
			<v-btn icon @click.stop="closeDialog">
				<v-icon>fa-times</v-icon>
			</v-btn>
			<v-toolbar-title>Task Details</v-toolbar-title>
			<v-spacer />
			<v-btn icon @click.stop="onEdit">
				<v-icon>fa-edit</v-icon>
			</v-btn>
			<v-dialog v-model="deleteDialog" max-width="20rem">
				<template #activator="{ on }">
					<v-btn icon v-on="on">
						<v-icon>fa-trash</v-icon>
					</v-btn>
				</template>

				<v-card>
					<v-card-title class="headline" primary-title>Are you sure?</v-card-title>
					<v-card-text>Are you sure you want to delete this task? This cannot be undone!</v-card-text>
					<v-card-actions>
						<v-spacer />
						<v-btn color="primary" text outlined @click="closeDeleteDialog">No</v-btn>
						<v-btn color="warning" text outlined @click="onDelete">Yes</v-btn>
					</v-card-actions>
				</v-card>
			</v-dialog>
		</v-toolbar>
		<task-dialog v-model="edit" :task-id="value.id" @input="reload" />

		<task-image disable-links :tasks="taskList" />

		<v-card-text>
			<h1 class="text--primary">{{ value.description }}</h1>
			<h3>Creation date: {{ value.creationDate }}</h3>
		</v-card-text>

		<v-card-actions class="justify-center">
			<v-checkbox
				class="big"
				v-model="value.done"
				:label="value.done ? 'Done' : 'To do'"
				@change="updateTaskDone"
			/>
		</v-card-actions>

		<v-card-actions>
			<v-list class="full-width">
				<task-list-item
					v-for="(subtask, i) in value.subtasks"
					:key="subtask.id"
					:task="subtask"
					@update="updateSubTask($event, i)"
				/>
			</v-list>
		</v-card-actions>
	</v-card>
</template>

<script>
import { Task, getColor } from "@/models/Task";
import TaskImage from "@/components/TaskImage";
import TaskDialog from "@/components/TaskDialog";
import TaskListItem from "@/components/TaskListItem";
import taskService from "@/mixins/TaskService";

export default {
	components: {
		TaskImage,
		TaskDialog,
		TaskListItem
	},

	mixins: [taskService],

	props: {
		value: {
			type: Task,
			required: true
		}
	},

	data() {
		return {
			deleteDialog: false,
			edit: false,
			taskList: [this.value]
		};
	},

	watch: {
		value(newValue) {
			this.taskList.splice(0, 1, newValue);
		}
	},

	methods: {
		getPriorityColor() {
			return getColor(this.value.priority);
		},

		onEdit() {
			this.edit = true;
		},

		editTask() {
			this.taskService.edit(this.value).then(t => this.$emit("input", t));
		},

		deleteTask() {
			this.taskService.remove(this.value.id);
		},

		closeDeleteDialog() {
			this.deleteDialog = false;
		},

		onDelete() {
			this.deleteTask().finally(() => this.$router.back());
		},

		closeDialog() {
			this.$emit("close");
		},

		updateTaskDone(done) {
			this.value.done = done;
			this.editTask();
		},

		updateSubTask(subtask, i) {
			this.value.subtasks[i] = subtask;
			this.editTask();
		},

		reload() {
			this.taskService.find(this.value.id).then(t => this.$emit("input", t));
		}
	}
};
</script>

<style lang="scss" scoped>
.full-width {
	width: 100%;
}
</style>